
// Apache AXIS
import org.apache.axis.AxisFault;
import org.apache.axis.Handler;
import org.apache.axis.Message;
import org.apache.axis.MessageContext;
import org.apache.axis.attachments.AttachmentPart;
import org.apache.axis.attachments.Attachments;
import org.apache.axis.handlers.BasicHandler;

// Java JAF (Java Activation Framework)
import javax.activation.DataHandler;

import java.lang.String;
import java.util.Iterator;
/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class AttachmentHandler extends BasicHandler {
	
	public AttachmentHandler() {
		
	}
	
		
	
    private AttachmentPart[] getMessageAttachments(MessageContext messageContext) 
                                          throws AxisFault {
       try {
       	    Message requestMessage = messageContext.getRequestMessage();
	    	Attachments messageAttachments = requestMessage.getAttachmentsImpl();
    		if (messageAttachments == null) {
    			return new AttachmentPart[0];
    		
	    	}	
    	
    		int attachmentCount = messageAttachments.getAttachmentCount();
    		AttachmentPart attachments[] = new AttachmentPart[attachmentCount];
	    	Iterator iterator = messageAttachments.getAttachments().iterator();
    		int count = 0;
    		while (iterator.hasNext()) {
    			AttachmentPart attachmentPart = (AttachmentPart) iterator.next();
	    		attachments[count++] = attachmentPart;
    		
    		}	
    		return attachments;
       } catch (Exception ex) {
       	   throw AxisFault.makeFault(ex);
       	
       }		
    	
    }	
    
    private String[] getFileNamesofAttachments(AttachmentPart attachments[],
                                                int attachmentCount) 
                                          throws AxisFault {
        try {
        	DataHandler dataHandler = null;
        	String[] fileNames = null;
        	int cnt = 0;
        	for (cnt = 0; cnt < attachmentCount; cnt++) {
        		dataHandler = attachments[cnt].getDataHandler();
        		fileNames[cnt] = dataHandler.getName();
        		
        	}	
        	return fileNames;
        	
        } catch (Exception ex) {
       	   throw AxisFault.makeFault(ex);
        	
        }		                                  	
                                          	
                                          	
    }                                          	
    
    
	public void invoke(MessageContext messageContext) throws AxisFault {
		
		try {
			AttachmentPart attachments[] = getMessageAttachments(messageContext);
			messageContext.setProperty("Attachments",attachments);

 	     	
	     	Message requestMessage = messageContext.getRequestMessage();
	     	int attachmentCount = requestMessage.countAttachments();
	     	String[] fileNames = getFileNamesofAttachments(attachments,attachmentCount);
	        messageContext.setProperty("File Names",fileNames); 

	        String cnt = java.lang.String.valueOf(attachmentCount);
            messageContext.setProperty("Attachment Count",cnt);	        

		} catch (Exception ex) {
			throw AxisFault.makeFault(ex);
			
		}		
		
	}	
	
	public void onFault(MessageContext messageContext) {
		try {
			
			
		} catch(Exception ex) {
//			throw new java.lang.Exception(ex.getMessage());
			
		}		
		
	}		
		
	

}
