﻿
using System.Diagnostics;
using System.Xml.Serialization;
using System;
using System.Collections;
using System.Data;
using System.Web;
using System.Net;
using System.Web.Services.Protocols;
using System.ComponentModel;
using Microsoft.Web;
using System.Web.Services;
using Microsoft.Web.Services;
using Microsoft.Web.Services.Dime;
using CustomFilterLibrary;

																																																																																																																																																																																																																																																																																																																												   
[System.Web.Services.WebServiceBindingAttribute(Name="FOPClientSoapBinding", 
	                                            Namespace="http://localhost:8080/axis/services/FOPService")]


public class FOPClient : Microsoft.Web.Services.WebServicesClientProtocol {
    
 
    public FOPClient() {
		/// If you want to run AXIS's tcpmon, comment it following.
		///
        this.Url = "http://localhost:8080/axis/services/FOPService";
		///

		/// If you want to run AXIS's tcpmon, un-comment following. Note that
		/// 8070 is tcpmon port, which forwards request to Web Server port (e.g. 8080).
		///
 //      	this.Url = "http://localhost:8070/axis/services/FOPService";
	}

    
    [System.Web.Services.Protocols.SoapRpcMethodAttribute("",Action="http://localhost:8080/axis/services/FOPService/fopService",
		                                                  RequestNamespace="http://localhost:8080/axis/services/FOPService",
		                                                  ResponseNamespace="http://localhost:8080/axis/services/FOPService")]
///		                                                  ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
    public void fopService(string format) {
		/// The Path property provides access to WS-Routing SOAP headers. Since AXIS
		/// does not support WS-Routing, it should be set to false.
		/// 
		this.RequestSoapContext.Path.MustUnderstand = false;
		/// Console.WriteLine("going to invoke....fopService..");
		/// 
		/// Invokes an XML Web service method synchronously using SOAP.
		/// method name of web sevice is fopService
		/// An array of object[] is pased as parameter for the fopService, which expects
		/// type of format for output (e.g. pdf).
		/// 
		this.Invoke("fopService", new object[] {
                    format});
		/// Console.WriteLine("successfully invoked....fopService..");
	}
	/// <summary>
	/// This is generated by wsdl.exe to invoke service asynchronously - Start of invocation.
	/// </summary>
	/// <param name="format"></param>
	/// <param name="callback"></param>
	/// <param name="asyncState"></param>
	/// <returns></returns>


	public System.IAsyncResult BeginfopService(string format, System.AsyncCallback callback, object asyncState) {
        return this.BeginInvoke("fopService", new object[] {
                    format}, callback, asyncState);
    }
	/// <summary>
	/// 
	/// </summary>
	/// <param name="asyncResult"></param>
	

    
    public void EndfopService(System.IAsyncResult asyncResult) {
        this.EndInvoke(asyncResult);
    }
	/// <summary>
	///    <list type="number">
	///        <item>
	///           <desfription>
	///           Opens an existing file for reading.
	///           Exposes Stream around file.
	///           Create and return DimeAttachment object.
	///           </description>
	///         </item>  
	///     </list>
	/// </summary>
	/// <param name="typeName">System.String that specifices type of docuemnt entity (e.g. text/xml</param>
	/// <param name="FilePath">System.String that represents the file name and absolute path for the attachment</param>
	/// <param name="typeFormatEnum">Microsoft.Web.Services.Dime.TypeFormatEnum specifying possible format for payload (e.g. MIME media) </param>
	/// <returns>Microsoft.Web.Services.Dime.DimeAttachment</returns>


	public Microsoft.Web.Services.Dime.DimeAttachment GetDimeAttachment(System.String typeName,
		                                                                System.String FilePath,
		                                                                Microsoft.Web.Services.Dime.TypeFormatEnum typeFormatEnum) {
		System.IO.FileStream stream = System.IO.File.OpenRead(FilePath);
		Microsoft.Web.Services.Dime.DimeAttachment dimeAttachment;
		dimeAttachment = new Microsoft.Web.Services.Dime.DimeAttachment(typeName,
			                                                            typeFormatEnum,
			                                                            stream);
		return dimeAttachment;

	}
	/// <summary>
	///    <list type="number">
	///        <item>
	///           <description>
	///                Creates streams that have memory as a backing store. 
	///                Writes the entire contents of this memory stream to another stream.
	///                Writes the entire stream contents to a byte array. 
	///           </description>
	///         </item>  
	///     </list>
	/// </summary>
	/// <param name="theStream">System.Io.Stream</param>
	/// <returns>byte[] array</returns>
	public static byte[] ConvertStreamToByteBuffer(System.IO.Stream theStream) 
	{
		if(theStream.Position>0 && theStream.CanSeek) theStream.Position=0;
		int b1;
		System.IO.MemoryStream tempStream = new System.IO.MemoryStream();
		while((b1=theStream.ReadByte())!=-1) 
		{
			tempStream.WriteByte(((byte)b1));
		}
		return tempStream.ToArray();
	}
	/// <summary>
	///    <list type="number">
	///        <item>
	///           <desfription>
	///                Calls ConvertsStreamToByteBuffer to convert stream read from 
	///                received attachment(e..g. from FOPWebService) to byte array.
	///                
	///           </description>
	///        </item>
	///        <item>
	///           <description>
	///               Manages local file (e.g create/open/delete, etc.).
	///               
	///           </description>    
	///        </item>
	///        <item>
	///           <description>
	///               Writes binary data to local file (e.g pdf).
	///               
	///           </description>    
	///        </item>
	///        <item>
	///           <description>
	///               Closes file.
	///               
	///           </description>    
	///        </item>
	///     </list>
	/// </summary>
	/// <param name="dimeAttachment">DIME Attachment object</param>
	/// <param name="LocalFileName">Absolute path of local file, including name</param>
	/// <returns>true</returns>
	public bool GetFile(DimeAttachment dimeAttachment,string LocalFileName) 
	{
		byte[] data = ConvertStreamToByteBuffer( dimeAttachment.Stream );
		if (data.Length == 0 ) 	{
			Console.WriteLine("did not find any  data..");


		}
		if(System.IO.File.Exists(LocalFileName)) System.IO.File.Delete(LocalFileName);
		System.IO.FileStream outfile = System.IO.File.OpenWrite(LocalFileName);
		outfile.Write(data, 0, data.Length);
		outfile.Close();
		return true;

	}

	/// <summary>
	///    <list type="number">
	///        <item>
	///           <description>
	///              Create instance of WSE's DimeAttachment class.
	///              Create attachments using GetDimeAttachment method call.
	///              Add attachment as payload to RequestSoapContext.
	///              Finally call fopService operation of FOPService, with specifying type of output format.
	///              FOPService converts attachments to specified outputformat and returns as SOAP message, with attachment.
	///              The ResponseContext includes attachment.
	///              GetFile method is called to convert attachment to loacl file (e.g. pdf format).
	///           </description>
	///         </item>  
	///     </list>
	///     <see cref="fopService"/>
	///     <see cref="GetFile"/>
	/// </summary>
	public  void Run() 
	{
        Microsoft.Web.Services.Dime.DimeAttachment dimeAttachment;
//		dimeAttachment = GetDimeAttachment("text/xml",@"d:\images\readme.fo", 
//			TypeFormatEnum.MediaType); 
//		this.RequestSoapContext.Attachments.Add(dimeAttachment);

		dimeAttachment = GetDimeAttachment("text/xml",@"c:\images\resume.xml", 
                                      TypeFormatEnum.MediaType); 
		this.RequestSoapContext.Attachments.Add(dimeAttachment);
		dimeAttachment = GetDimeAttachment("text/xml",@"c:\images\resume.xsl", 
			TypeFormatEnum.MediaType); 
		this.RequestSoapContext.Attachments.Add(dimeAttachment);
		try 
		{
			this.fopService("PDF");
		} 
		catch (Exception e) 
		{
//			Console.WriteLine("i receieed client exception.." + e.Message);

		}
		finally 
		{

		}
		if (this.ResponseSoapContext.Attachments.Count == 1)
		{
			dimeAttachment = this.ResponseSoapContext.Attachments[0];
			GetFile(dimeAttachment,@"c:\images\temp.pdf");
		}
	}


	/// <summary>
	///    <list type="number">
	///        <item>
	///           <description>
	///              Main entry point for FOPClient.
	///              Creates a new instance of FOPClient class.
	///              Calls Run method to do further processing.
	///              Create instance of WSE's DimeAttachment class.
	///           </description>
	///         </item>  
	///     </list>
	///     <see cref="Run"/>
	/// </summary>
	public static void Main() 	
	{
		FOPClient client = new FOPClient();
//		client.Pipeline.OutputFilters.Add(new SoapFaultOutputFilter());
		client.Pipeline.InputFilters.Add(new SoapFaultInputFilter());
//        client.RequestSoapContext["soapfault"] = "this is a first test falut"; 
//		Console.WriteLine("Created FOPClient");
		client.Run();

	}

	
 
}
